.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

INCLUDE    \masm32\INCLUDE\windows.inc
INCLUDE    \masm32\INCLUDE\user32.inc
INCLUDE    \masm32\INCLUDE\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

.CONST

IDM_START_THREAD EQU 1
IDM_STOP_THREAD  EQU 2
IDM_EXIT         EQU 3
WM_FINISH        EQU WM_USER+100h

.DATA

ClassName     DB "Win32ASMEventClass", 0
AppName       DB "Przykad Zdarzenia", 0
MenuName      DB "FirstMenu", 0
SuccessString DB "Obliczenia zakoczone!", 0
StopString    DB "Wtek zatrzymany", 0
EventStop     BOOL FALSE

.DATA?

hInstance   HINSTANCE ?
CommandLine LPSTR     ?
hwnd        HANDLE    ?
hMenu       HANDLE    ?
ThreadID    DWORD     ?
ExitCode    DWORD     ?
hEventStart HANDLE    ?

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE GetCommandLine
    mov    CommandLine, eax
    INVOKE WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax

WinMain PROC hInst:     HINSTANCE,\
             hPrevInst: HINSTANCE,\
             CmdLine:   LPSTR,\
             CmdShow:   DWORD

LOCAL wc:  WNDCLASSEX
LOCAL msg: MSG

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInst
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszMenuName, OFFSET MenuName
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, WS_EX_CLIENTEDGE,\
                           ADDR ClassName, ADDR AppName,\
                           WS_OVERLAPPEDWINDOW, CW_USEDEFAULT,\
                           CW_USEDEFAULT, 300, 200, NULL, NULL,\
                           hInst, NULL
    mov    hwnd, eax
    INVOKE ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwnd
    INVOKE GetMenu, hwnd
    mov    hMenu, eax

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMessage, ADDR msg
        INVOKE DispatchMessage, ADDR msg
    .ENDW

    mov eax, msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    .IF uMsg==WM_CREATE
        INVOKE CreateEvent, NULL, FALSE, FALSE, NULL
        mov    hEventStart, eax
        mov    eax, OFFSET ThreadProc
        INVOKE CreateThread, NULL, NULL, eax,\
                             NULL, NORMAL_PRIORITY_CLASS,\
                             ADDR ThreadID
        INVOKE CloseHandle, eax
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSEIF uMsg==WM_COMMAND
        mov eax, wParam
        .IF lParam==0
            .IF ax==IDM_START_THREAD
                INVOKE SetEvent, hEventStart
                INVOKE EnableMenuItem, hMenu, IDM_START_THREAD, MF_GRAYED
                INVOKE EnableMenuItem, hMenu, IDM_STOP_THREAD, MF_ENABLED
            .ELSEIF ax==IDM_STOP_THREAD
                mov    EventStop, TRUE
                INVOKE EnableMenuItem, hMenu, IDM_START_THREAD, MF_ENABLED
                INVOKE EnableMenuItem, hMenu, IDM_STOP_THREAD, MF_GRAYED
            .ELSE
                INVOKE DestroyWindow, hWnd
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_FINISH
        INVOKE MessageBox, NULL, ADDR SuccessString, ADDR AppName, MB_OK
    .ELSE
        INVOKE DefWindowProc, hWnd, uMsg, wParam, lParam
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

ThreadProc PROC USES ecx Param:DWORD

ThreadLoop:
    INVOKE WaitForSingleObject, hEventStart, INFINITE
    mov    ecx, 600000000

    .WHILE ecx!=0
        .IF EventStop==FALSE
            add  eax, eax
            dec  ecx
        .ELSE
            INVOKE MessageBox, hwnd, ADDR StopString, ADDR AppName, MB_OK
            mov    EventStop, FALSE
            jmp    ThreadLoop
        .ENDIF
    .ENDW

    INVOKE PostMessage, hwnd, WM_FINISH, NULL, NULL
    INVOKE EnableMenuItem, hMenu, IDM_START_THREAD, MF_ENABLED
    INVOKE EnableMenuItem, hMenu, IDM_STOP_THREAD, MF_GRAYED
    jmp    ThreadLoop

ThreadProc ENDP

END start
